/*
 * Adapted from file of same name by Bent Dalgaard Larsen.
 * http://www.imm.dtu.dk/~bdl/02561/radiosity/
 *
 */

#ifndef __HEMICUBE_H__
#define __HEMICUBE_H__

#include "Mesh.h"
#include "Vec3.h"
#include <SDL/SDL_opengl.h>

#include <vector>

namespace ambenv {

  typedef void (*render_scene_callback)( const class Mesh * );
  
  class Hemicube {
  private:
    unsigned m_size;	

  public:
    Hemicube( unsigned size );
    void renderScene( const MeshVertex & vertex, const Mesh * mesh, 
		      render_scene_callback callback );

    void computeWeightsAndNormals( std::vector<Real> & weights, 
				   std::vector<Vec3> & normals );

  };
}; /* namespace ambenv */

#endif // __HEMICUBE_H__
