#ifndef __INSTANCE_H_
#define __INSTANCE_H_

#include "Object.h"
#include "Transformable.h"

#include <string>

namespace ambenv {

  class Instance : public Transformable {
 
  public:
    Instance();
    Instance( const std::string & name, const std::string & material, const Object * obj );

    // - get accessors
    std::string name() const;
    std::string material() const;
    const Object * object() const;

    // - set accessors
    void name( const std::string & name );
    void material( const std::string & name );

    bool intersect( const Ray & ray, Real epsilon = 0.0 ) const;

  private:
    std::string m_name;
    std::string m_material;
    //! not responsible for deleting these
    const Object * m_object;
  };
}; /* namespace ambenv */

#endif /* __INSTANCE_H_ */
