#ifndef __RAY_H_
#define __RAY_H_

#include "Vec3.h"

namespace ambenv {

  class Ray {
  public:
    Ray();
    Ray( const Vec3 & origin, const Vec3 & direction );
    
    Vec3 evaluate( Real t ) const; //! evaluate ray at t and return point

    Vec3 getOrigin() const;
    Vec3 getDirection() const;

  private:
    Vec3 m_origin; //! origin of ray
    Vec3 m_direction; //! direction of ray
  };

}; /* namespace ambenv */

#endif /* __RAY_H_ */
